use crate::bot::start_bot;
use crate::config::{Args, BotConfig};
use log::{debug, error};
use structopt::StructOpt;

mod bot;
mod config;
mod context;

#[tokio::main]
async fn main() {
    env_logger::init();

    let args = Args::from_args();
    debug!("Loading config at '{:?}'", args.config_path);

    let config = match BotConfig::new(&args.config_path) {
        Ok(c) => c,
        Err(err) => {
            error!("Error loading config: {}", err);
            return;
        }
    };

    start_bot(config).await;
}
